#include "mcp3202.h"
#include "lcd.h"


void mcp3202_init (void)
{
	/*configure SPI*/
	SPCR = (1<<SPE)|(1<<MSTR)|(1<<SPR0);
	/*configure DDRx*/
	SPI_DDR = (1<<AD_CS) | (1<<AD_SS) | (1<<AD_MOSI) | (1<<AD_SCK);
	SPI_PORT = (1<<AD_CS) | (1<<AD_SS);
}


unsigned short mcp3202_get_value (unsigned char channel)
{
	unsigned short byte_rec = 0;
	
	/*select device*/
	SPI_PORT &= ~(1<<AD_CS);
	/*send start bit*/
	SPDR = 0x01;
	/*wait, until transmission is completed*/
	while(!(SPSR & (1<<SPIF)));

	/*select mode und channel:
	single ended mode, MSB first*/
	SPDR = 0b10000000 | (channel << 6);
	/*wait, until transmission is completed*/
	while(!(SPSR & (1<<SPIF)));
	byte_rec = (SPDR << 8);

	/*write dummy byte, to receive the lower bits of the converted voltage*/
	SPDR = 0x00;
	/*wait, until transmission is completed*/
	while(!(SPSR & (1<<SPIF)));
	byte_rec |= SPDR;
	/*deselect device*/
	SPI_PORT |= (1<<AD_CS);
	return (byte_rec & 0b0000111111111111);
}
